using System;
using Microsoft.Web.Services2;
using Microsoft.Web.Services2.Security.Tokens;
using Microsoft.Web.Services2.Security.X509;

public class Certificate
{
	private static string[] clients;
	public static string bankCert = "First Bank";

	static Certificate()
	{
		clients = new string[2];
		clients[0] = "CN=Mary Monroe";
		clients[1] = "CN=Peter Piper";
	}

	public static bool IsClientCertificateValid(X509Certificate cert)
	{
		// not using stores and revocation lists for simplicity
		if (cert.IsCurrent == false)
			return false;

		string clientName = cert.GetName();

		foreach (string name in clients)
		{
			if (clientName == name)
				return true;
		}

		return false;
	}

	public static X509Certificate GetCertificate(string subjectString)
	{
		X509CertificateStore store = X509CertificateStore.LocalMachineStore(X509CertificateStore.MyStore);
		
		bool open = store.OpenRead();
		if (open == false)
			return null;

		X509CertificateCollection certs = store.FindCertificateBySubjectString(subjectString);
		store.Close();
		X509Certificate cert = (X509Certificate)certs[0];

		return cert;
	}

	public static void AddCertificate(SoapContext context, X509Certificate cert)
	{
		X509SecurityToken token = new X509SecurityToken(cert);
		context.Security.Tokens.Add(token);
		return;
	}
}
