using System;
using System.Web.Services.Protocols;

using Microsoft.Web.Services2;
using Microsoft.Web.Services2.Addressing;
using Microsoft.Web.Services2.Messaging;
using Microsoft.Web.Services2.Security;
using Microsoft.Web.Services2.Security.Tokens;
using Microsoft.Web.Services2.Security.X509;

public class Loan
{
	public string name;
	public int amount;
}

public class LoanService : SoapReceiver
{
    protected override void Receive( SoapEnvelope message )
    {
        if( message.Context.Addressing.Action.Value == "urn:LoanRequest" )
        {
			Loan loan = (Loan)message.GetBodyObject(typeof(Loan));
            Console.WriteLine("Loan Request received for {0} in the amount of {1}", loan.name, loan.amount);

			EndpointReference er = new EndpointReference(message.Context.Addressing.ReplyTo.Address.Value);
	
			SoapEnvelope response = new SoapEnvelope();
			response.Context.Addressing.Action = new Action("urn:LoanResponse");

			string result = "not approved";

			UsernameToken usernameToken = null;
			foreach (UsernameToken token in message.Context.Security.Tokens)
			{
				usernameToken = token;
				break;
			}
			
			if (usernameToken.Username == "peter")
				result = "approved.";
			else if (usernameToken.Username == "mary")
				result = "not approved.";

			response.SetBodyObject(result);
			
			SoapSender sender = new SoapSender(er);
			sender.Send(response);
       }
    }
}














